<template>
  <div
    class="w-full h-full fixed top-0 left-0 lg:block transition-opacity z-10"
    :class="{ hidden: !getSideMenuState() }"
  >
    <aside class="aside absolute z-20 lg:relative">
      <div class="flex flex-nowrap gap-2 items-center h-12 w-full">
        <img class="w-9 h-9" :src="require('~/assets/img/logo.png')" />
        <span class="text-lg font-semibold text-gray-700">Muse Dashboard</span>
      </div>
      <p class="h-10"></p>
      <ul
        class="grid gap-1"
        v-for="(routeSection, sId) in Object.keys(routes)"
        :key="sId"
      >
        <span class="text-lg font-semibold text-gray-500" v-if="routeSection"
          >{{ capitalize(routeSection) }} Pages
        </span>
        <li v-for="(routeName, rId) in routes[routeSection]" :key="rId">
          <div class="side-menu-section" @click="$store.commit('hideSideMenu')">
            <nuxt-link :to="getRoute(routeName, routeSection)">{{
              capitalize(routeName)
            }}</nuxt-link>
            <Icon :name="getIcon(routeName)"></Icon>
          </div>
        </li>
      </ul>
    </aside>
    <div
      @click="$store.commit('hideSideMenu')"
      class="w-full h-full bg-black bg-opacity-50 absolute top-0 left-0 z-10 lg:hidden"
    ></div>
  </div>
</template>

<style lang="scss">
.aside {
  @apply bg-white grid auto-rows-min gap-4 items-start justify-center overflow-y-scroll	h-full w-64 px-5 py-8;
}
.side-menu-section {
  @apply flex flex-nowrap gap-2 items-center justify-start h-12 text-lg font-normal text-gray-700;
}

.side-menu-section svg path {
  width: 20px;
  height: 20px;
  fill: #bfbfbf;
}

.side-menu-section i {
  order: -1;
  width: 2em;
  height: 2em;
  display: flex;
  justify-content: center;
  align-items: center;
  border-radius: 0.3em;
}
</style>

<script lang="ts">
import { mapGetters } from "vuex";
import { capitalize } from "@/utils";

export default {
  data() {
    return {
      routes: {
        "": ["Dashboard", "Tables", "Billing"],
        account: ["Profile", "Sign In", "Sign Up"]
      }
    };
  },
  methods: {
    ...mapGetters(["getSideMenuState"]),
    capitalize,
    getIcon(routeName: string) {
      return routeName
        .split(" ")
        .join("")
        .toLowerCase();
    },
    getRoute(routeName: string, parentRoute: string = "") {
      return parentRoute
        ? `/${parentRoute}/${this.getIcon(routeName)}`
        : `/${this.getIcon(routeName)}`;
    }
  }
};
</script>
